// Portions Copyright (C) 2000, Matt Saettler.  All Rights Reserved.
#include "duke3d.h"
#include "concom.h"

char dodge(spritetype *s)
{
	short i;
	long bx,by,mx,my,bxvect,byvect,mxvect,myvect,d;

	mx = s->x;
	my = s->y;
	mxvect = sintable[(s->ang+512)&2047]; myvect = sintable[s->ang&2047];

	for(i=headspritestat[4];i>=0;i=nextspritestat[i]) //weapons list
	{
		if( OW == i || SECT != s->sectnum)
			continue;

		bx = SX-mx;
		by = SY-my;
		bxvect = sintable[(SA+512)&2047]; byvect = sintable[SA&2047];

		if (mxvect*bx + myvect*by >= 0)
			if (bxvect*bx + byvect*by < 0)
		{
			d = bxvect*by - byvect*bx;
			if (klabs(d) < 65536*64)
			{
				s->ang -= 512+(TRAND&1024);
				return 1;
			}
		}
	}
	return 0;
}

short furthestangle(short i,short angs)
{
	short j, hitsect,hitwall,hitspr,furthest_angle, angincs;
	long hx, hy, hz, d, greatestd;
	spritetype *s = &sprite[i];

	greatestd = -(1<<30);
	angincs = 2048/angs;

	if(s->picnum != APLAYER)
		if( (g_t[0]&63) > 2 ) return( s->ang + 1024 );

	for(j=s->ang;j<(2048+s->ang);j+=angincs)
	{
		hitscan(s->x, s->y, s->z-(8<<8), s->sectnum,
			sintable[(j+512)&2047],
			sintable[j&2047],0,
			&hitsect,&hitwall,&hitspr,&hx,&hy,&hz,CLIPMASK1);

		d = klabs(hx-s->x) + klabs(hy-s->y);

		if(d > greatestd)
		{
			greatestd = d;
			furthest_angle = j;
		}
	}
	return (furthest_angle&2047);
}

short furthestcanseepoint(short i,spritetype *ts,long *dax,long *day)
{
	short j, hitsect,hitwall,hitspr, angincs, tempang;
	long hx, hy, hz, d, da;//, d, cd, ca,tempx,tempy,cx,cy;
	spritetype *s = &sprite[i];

	if( (g_t[0]&63) ) return -1;

	if(ud.multimode < 2 && ud.player_skill < 3)
		angincs = 2048/2;
	else angincs = 2048/(1+(TRAND&1));

	for(j=ts->ang;j<(2048+ts->ang);j+=(angincs-(TRAND&511)))
	{
		hitscan(ts->x, ts->y, ts->z-(16<<8), ts->sectnum,
			sintable[(j+512)&2047],
			sintable[j&2047],16384-(TRAND&32767),
			&hitsect,&hitwall,&hitspr,&hx,&hy,&hz,CLIPMASK1);

		d = klabs(hx-ts->x)+klabs(hy-ts->y);
		da = klabs(hx-s->x)+klabs(hy-s->y);

		if( d < da )
			if(cansee(hx,hy,hz,hitsect,s->x,s->y,s->z-(16<<8),s->sectnum))
		{
			*dax = hx;
			*day = hy;
			return hitsect;
		}
	}
	return -1;
}




void alterang(short a)
{
	short aang, angdif, goalang,j;
	long ticselapsed, *moveptr;

	moveptr = (long *)g_t[1];

	ticselapsed = (g_t[0])&31;

	aang = g_sp->ang;

	g_sp->xvel += (*moveptr-g_sp->xvel)/5;
	if(g_sp->zvel < 648) g_sp->zvel += ((*(moveptr+1)<<4)-g_sp->zvel)/5;

	if(a&seekplayer)
	{
		j = ps[g_p].holoduke_on;

// NOTE: looks like 'owner' is set to target sprite ID...
		
		if(j >= 0 && cansee(sprite[j].x,sprite[j].y,sprite[j].z,sprite[j].sectnum,g_sp->x,g_sp->y,g_sp->z,g_sp->sectnum) )
			g_sp->owner = j;
		else g_sp->owner = ps[g_p].i;

		if(sprite[g_sp->owner].picnum == APLAYER)
			goalang = getangle(hittype[g_i].lastvx-g_sp->x,hittype[g_i].lastvy-g_sp->y);
		else
			goalang = getangle(sprite[g_sp->owner].x-g_sp->x,sprite[g_sp->owner].y-g_sp->y);

		if(g_sp->xvel && g_sp->picnum != DRONE)
		{
			angdif = getincangle(aang,goalang);

			if(ticselapsed < 2)
			{
				if( klabs(angdif) < 256)
				{
					j = 128-(TRAND&256);
					g_sp->ang += j;
					if( hits(g_i) < 844 )
						g_sp->ang -= j;
				}
			}
			else if(ticselapsed > 18 && ticselapsed < 26) // choose
			{
				if(klabs(angdif>>2) < 128) g_sp->ang = goalang;
				else g_sp->ang += angdif>>2;
			}
		}
		else g_sp->ang = goalang;
	}

	if(ticselapsed < 1)
	{
		j = 2;
		if(a&furthestdir)
		{
			goalang = furthestangle(g_i,j);
			g_sp->ang = goalang;
			g_sp->owner = ps[g_p].i;
		}

		if(a&fleeenemy)
		{
			goalang = furthestangle(g_i,j);
			g_sp->ang = goalang; // += angdif; //  = getincangle(aang,goalang)>>1;
		}
	}
}

void move()
{
	long l, *moveptr;
	short j, a, goalang, angdif;
	long daxvel;

	a = g_sp->hitag;

	if(a == -1) a = 0;

	g_t[0]++;

	if(a&face_player)
	{
		if(ps[g_p].newowner >= 0)
			goalang = getangle(ps[g_p].oposx-g_sp->x,ps[g_p].oposy-g_sp->y);
		else goalang = getangle(ps[g_p].posx-g_sp->x,ps[g_p].posy-g_sp->y);
		angdif = getincangle(g_sp->ang,goalang)>>2;
		if(angdif > -8 && angdif < 0) angdif = 0;
		g_sp->ang += angdif;
	}

	if(a&spin)
		g_sp->ang += sintable[ ((g_t[0]<<3)&2047) ]>>6;

	if(a&face_player_slow)
	{
		if(ps[g_p].newowner >= 0)
			goalang = getangle(ps[g_p].oposx-g_sp->x,ps[g_p].oposy-g_sp->y);
		else goalang = getangle(ps[g_p].posx-g_sp->x,ps[g_p].posy-g_sp->y);
		angdif = ksgn(getincangle(g_sp->ang,goalang))<<5;
		if(angdif > -32 && angdif < 0)
		{
			angdif = 0;
			g_sp->ang = goalang;
		}
		g_sp->ang += angdif;
	}


	if((a&jumptoplayer) == jumptoplayer)
	{
		if(g_t[0] < 16)
			g_sp->zvel -= (sintable[(512+(g_t[0]<<4))&2047]>>5);
	}

	if(a&face_player_smart)
	{
		long newx,newy;

		newx = ps[g_p].posx+(ps[g_p].posxv/768);
		newy = ps[g_p].posy+(ps[g_p].posyv/768);
		goalang = getangle(newx-g_sp->x,newy-g_sp->y);
		angdif = getincangle(g_sp->ang,goalang)>>2;
		if(angdif > -8 && angdif < 0) angdif = 0;
		g_sp->ang += angdif;
	}

	if( g_t[1] == 0 || a == 0 )
	{
		if( ( badguy(g_sp) && g_sp->extra <= 0 ) || (hittype[g_i].bposx != g_sp->x) || (hittype[g_i].bposy != g_sp->y) )
		{
			hittype[g_i].bposx = g_sp->x;
			hittype[g_i].bposy = g_sp->y;
			setsprite(g_i,g_sp->x,g_sp->y,g_sp->z);
		}
		return;
	}

	moveptr = (long *)g_t[1];

	if(a&geth) g_sp->xvel += (*moveptr-g_sp->xvel)>>1;
	if(a&getv) g_sp->zvel += ((*(moveptr+1)<<4)-g_sp->zvel)>>1;

	if(a&dodgebullet)
		dodge(g_sp);

	if(g_sp->picnum != APLAYER)
		alterang(a);

	if(g_sp->xvel > -6 && g_sp->xvel < 6 ) g_sp->xvel = 0;

	a = badguy(g_sp);

	if(g_sp->xvel || g_sp->zvel)
	{
		if(a && g_sp->picnum != ROTATEGUN)
		{
			if( (g_sp->picnum == DRONE || g_sp->picnum == COMMANDER) && g_sp->extra > 0)
			{
				if(g_sp->picnum == COMMANDER)
				{
					hittype[g_i].floorz = l = getflorzofslope(g_sp->sectnum,g_sp->x,g_sp->y);
					if( g_sp->z > (l-(8<<8)) )
					{
						if( g_sp->z > (l-(8<<8)) ) g_sp->z = l-(8<<8);
						g_sp->zvel = 0;
					}

					hittype[g_i].ceilingz = l = getceilzofslope(g_sp->sectnum,g_sp->x,g_sp->y);
					if( (g_sp->z-l) < (80<<8) )
					{
						g_sp->z = l+(80<<8);
						g_sp->zvel = 0;
					}
				}
				else
				{
					if( g_sp->zvel > 0 )
					{
						hittype[g_i].floorz = l = getflorzofslope(g_sp->sectnum,g_sp->x,g_sp->y);
						if( g_sp->z > (l-(30<<8)) )
							g_sp->z = l-(30<<8);
					}
					else
					{
						hittype[g_i].ceilingz = l = getceilzofslope(g_sp->sectnum,g_sp->x,g_sp->y);
						if( (g_sp->z-l) < (50<<8) )
						{
							g_sp->z = l+(50<<8);
							g_sp->zvel = 0;
						}
					}
				}
			}
			else if(g_sp->picnum != ORGANTIC)
			{
				if(g_sp->zvel > 0 && hittype[g_i].floorz < g_sp->z)
					g_sp->z = hittype[g_i].floorz;
				if( g_sp->zvel < 0)
				{
					l = getceilzofslope(g_sp->sectnum,g_sp->x,g_sp->y);
					if( (g_sp->z-l) < (66<<8) )
					{
						g_sp->z = l+(66<<8);
						g_sp->zvel >>= 1;
					}
				}
			}
		}
		else if(g_sp->picnum == APLAYER)
			if( (g_sp->z-hittype[g_i].ceilingz) < (32<<8) )
				g_sp->z = hittype[g_i].ceilingz+(32<<8);

		daxvel = g_sp->xvel;
		angdif = g_sp->ang;

		if( a && g_sp->picnum != ROTATEGUN )
		{
			if( g_x < 960 && g_sp->xrepeat > 16 )
			{

				daxvel = -(1024-g_x);
				angdif = getangle(ps[g_p].posx-g_sp->x,ps[g_p].posy-g_sp->y);

				if(g_x < 512)
				{
					ps[g_p].posxv = 0;
					ps[g_p].posyv = 0;
				}
				else
				{
					ps[g_p].posxv = mulscale(ps[g_p].posxv,dukefriction-0x2000,16);
					ps[g_p].posyv = mulscale(ps[g_p].posyv,dukefriction-0x2000,16);
				}
			}
			else if(g_sp->picnum != DRONE && g_sp->picnum != SHARK && g_sp->picnum != COMMANDER)
			{
				if( hittype[g_i].bposz != g_sp->z || ( ud.multimode < 2 && ud.player_skill < 2 ) )
				{
					if( (g_t[0]&1) || ps[g_p].actorsqu == g_i ) return;
					else daxvel <<= 1;
				}
				else
				{
					if( (g_t[0]&3) || ps[g_p].actorsqu == g_i ) return;
					else daxvel <<= 2;
				}
			}
		}

		hittype[g_i].movflag = movesprite(g_i,
			(daxvel*(sintable[(angdif+512)&2047]))>>14,
			(daxvel*(sintable[angdif&2047]))>>14,g_sp->zvel,CLIPMASK0);
   }

   if( a )
   {
	   if (sector[g_sp->sectnum].ceilingstat&1)
		   g_sp->shade += (sector[g_sp->sectnum].ceilingshade-g_sp->shade)>>1;
	   else g_sp->shade += (sector[g_sp->sectnum].floorshade-g_sp->shade)>>1;

	   if( sector[g_sp->sectnum].floorpicnum == MIRROR )
		   deletesprite(g_i);
   }
}
