//-------------------------------------------------------------------------
/*
Copyright (C) 2000, 2003 - Matt Saettler (EDuke Enhancements)

This file is part of Enhanced Duke Nukem 3D version 1.5 - Atomic Edition

Duke Nukem 3D is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Original Source: 1996 - Todd Replogle
Prepared for public release: 03/21/2003 - Charlie Wiederhold, 3D Realms

EDuke enhancements integrated: 04/13/2003 - Matt Saettler

Note: EDuke source was in transition.  Changes are in-progress in the
source as it is released.

*/
//-------------------------------------------------------------------------
#include "duke3d.h"
#include "concom.h"
#include "runvar.h"


int g_iReturnVarID=-1;	// var ID of "RETURN"
int g_iWeaponVarID=-1;	// var ID of "WEAPON"
int g_iWorksLikeVarID=-1;	// var ID of "WORKSLIKE"
int g_iZRangeVarID=-1;	// var ID of "ZRANGE"
int g_iAngRangeVarID=-1;	// var ID of "ANGRANGE"
int g_iAimAngleVarID=-1;	// var ID of "AUTOAIMANGLE"
int g_iAtWithVarID=-1;	// var ID of "AtWith"

int g_iLoTagID=-1;			// var ID of "LOTAG"
int g_iHiTagID=-1;			// ver ID of "HITAG"
int g_iTextureID=-1;		// var ID of "TEXTURE"
int g_iThisActorID=-1;		// var ID of "THISACTOR"


// globals for game variables.  mostly from displayweapon() player.c
    long g_gun_pos, g_looking_arc, g_currentweapon;
    long g_weapon_xoffset;
//    char o,pal;
    long g_gs;
//    struct player_struct *p;
    long g_kb;

	long g_looking_angSR1;


void DoUserDef(char bSet, long lVar1, long lLabelID, long lVar2, short sActor, short sPlayer, long lParm2)
{
	int iPlayer;
	long lValue;

	lValue=GetGameVarID((int)lVar2, sActor, sPlayer);
	
	switch(lLabelID)
	{
		case PLAYER_ZOOM:
			if(bSet)
			{
				ps[iPlayer].zoom=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].zoom, sActor, sPlayer);
			}
			break;

		case USERDEFS_GOD:
			if(bSet)
			{
				ud.god = lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ud.god, sActor, sPlayer);
			}
			break;

		case USERDEFS_WARP_ON:
			if(bSet)
			{
				ud.warp_on = lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ud.warp_on, sActor, sPlayer);
			}
			break;

		case USERDEFS_CASHMAN:
			if(bSet)
			{
				ud.cashman = lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ud.cashman, sActor, sPlayer);
			}
			break;

	case USERDEFS_EOG:
			if(bSet)
			{
				ud.eog = lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ud.eog, sActor, sPlayer);
			}
			break;

	case USERDEFS_SHOWALLMAP:
		if(bSet)
		{
			ud.showallmap = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.showallmap, sActor, sPlayer);
		}
		break;

	case USERDEFS_SHOW_HELP:
		if(bSet)
		{
			ud.show_help = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.show_help, sActor, sPlayer);
		}
		break;

	case USERDEFS_SCROLLMODE:
		if(bSet)
		{
			ud.scrollmode = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.scrollmode, sActor, sPlayer);
		}
		break;

	case USERDEFS_CLIPPING:
		if(bSet)
		{
			ud.clipping = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.clipping, sActor, sPlayer);
		}
		break;

//	case USERDEFS_USER_NAME:
//		if(bSet)
//		{
//			ud.user_name[MAXPLAYERS][32] = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.user_name[MAXPLAYERS][32], sActor, sPlayer);
//		}
//		break;

//	case USERDEFS_RIDECULE:
//		if(bSet)
//		{
//			ud.ridecule = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.ridecule, sActor, sPlayer);
//		}
//		break;

//	case USERDEFS_SAVEGAME:
//		if(bSet)
//		{
//			ud.savegame = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.savegame, sActor, sPlayer);
//		}
//		break;

//	case USERDEFS_PWLOCKOUT:
//		if(bSet)
//		{
//			ud.pwlockout = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.pwlockout, sActor, sPlayer);
//		}
//		break;

//	case USERDEFS_RTSNAME:
//		if(bSet)
//		{
//			ud.rtsname = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.rtsname, sActor, sPlayer);
//		}
//		break;

	case USERDEFS_OVERHEAD_ON:
		if(bSet)
		{
			ud.overhead_on = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.overhead_on, sActor, sPlayer);
		}
		break;

	case USERDEFS_LAST_OVERHEAD:
		if(bSet)
		{
			ud.last_overhead = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.last_overhead, sActor, sPlayer);
		}
		break;

	case USERDEFS_SHOWWEAPONS:
		if(bSet)
		{
			ud.showweapons = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.showweapons, sActor, sPlayer);
		}
		break;


	case USERDEFS_PAUSE_ON:
		if(bSet)
		{
			ud.pause_on = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.pause_on, sActor, sPlayer);
		}
		break;

	case USERDEFS_FROM_BONUS:
		if(bSet)
		{
			ud.from_bonus = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.from_bonus, sActor, sPlayer);
		}
		break;

	case USERDEFS_CAMERASPRITE:
		if(bSet)
		{
			ud.camerasprite = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.camerasprite, sActor, sPlayer);
		}
		break;

	case USERDEFS_LAST_CAMSPRITE:
		if(bSet)
		{
			ud.last_camsprite = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.last_camsprite, sActor, sPlayer);
		}
		break;

	case USERDEFS_LAST_LEVEL:
		if(bSet)
		{
			ud.last_level = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.last_level, sActor, sPlayer);
		}
		break;

	case USERDEFS_SECRETLEVEL:
		if(bSet)
		{
			ud.secretlevel = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.secretlevel, sActor, sPlayer);
		}
		break;


	case USERDEFS_CONST_VISIBILITY:
		if(bSet)
		{
			ud.const_visibility = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.const_visibility, sActor, sPlayer);
		}
		break;

	case USERDEFS_UW_FRAMERATE:
		if(bSet)
		{
			ud.uw_framerate = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.uw_framerate, sActor, sPlayer);
		}
		break;

	case USERDEFS_CAMERA_TIME:
		if(bSet)
		{
			ud.camera_time = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.camera_time, sActor, sPlayer);
		}
		break;

	case USERDEFS_FOLFVEL:
		if(bSet)
		{
			ud.folfvel = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.folfvel, sActor, sPlayer);
		}
		break;

	case USERDEFS_FOLAVEL:
		if(bSet)
		{
			ud.folavel = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.folavel, sActor, sPlayer);
		}
		break;

	case USERDEFS_FOLX:
		if(bSet)
		{
			ud.folx = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.folx, sActor, sPlayer);
		}
		break;

	case USERDEFS_FOLY:
		if(bSet)
		{
			ud.foly = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.foly, sActor, sPlayer);
		}
		break;

	case USERDEFS_FOLA:
		if(bSet)
		{
			ud.fola = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.fola, sActor, sPlayer);
		}
		break;

	case USERDEFS_RECCNT:
		if(bSet)
		{
			ud.reccnt = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.reccnt, sActor, sPlayer);
		}
		break;


	case USERDEFS_ENTERED_NAME:
		if(bSet)
		{
			ud.entered_name = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.entered_name, sActor, sPlayer);
		}
		break;

	case USERDEFS_SCREEN_TILTING:
		if(bSet)
		{
			ud.screen_tilting = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.screen_tilting, sActor, sPlayer);
		}
		break;

	case USERDEFS_SHADOWS:
		if(bSet)
		{
			ud.shadows = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.shadows, sActor, sPlayer);
		}
		break;

	case USERDEFS_FTA_ON:
		if(bSet)
		{
			ud.fta_on = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.fta_on, sActor, sPlayer);
		}
		break;

	case USERDEFS_EXECUTIONS:
		if(bSet)
		{
			ud.executions = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.executions, sActor, sPlayer);
		}
		break;

	case USERDEFS_AUTO_RUN:
		if(bSet)
		{
			ud.auto_run = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.auto_run, sActor, sPlayer);
		}
		break;

	case USERDEFS_COORDS:
		if(bSet)
		{
			ud.coords = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.coords, sActor, sPlayer);
		}
		break;

	case USERDEFS_TICKRATE:
		if(bSet)
		{
			ud.tickrate = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.tickrate, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_COOP:
		if(bSet)
		{
			ud.m_coop = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_coop, sActor, sPlayer);
		}
		break;

	case USERDEFS_COOP:
		if(bSet)
		{
			ud.coop = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.coop, sActor, sPlayer);
		}
		break;

	case USERDEFS_SCREEN_SIZE:
		if(bSet)
		{
			ud.screen_size = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.screen_size, sActor, sPlayer);
		}
		break;

	case USERDEFS_LOCKOUT:
		if(bSet)
		{
			ud.lockout = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.lockout, sActor, sPlayer);
		}
		break;

	case USERDEFS_CROSSHAIR:
		if(bSet)
		{
			ud.crosshair = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.crosshair, sActor, sPlayer);
		}
		break;

//	case USERDEFS_WCHOICE:
//		if(bSet)
//		{
//			ud.wchoice = lValue;
//		}
//		else
//		{
//			SetGameVarID((int)lVar2, ud.wchoice, sActor, sPlayer);
//		}
//		break;

	case USERDEFS_PLAYERAI:
		if(bSet)
		{
			ud.playerai = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.playerai, sActor, sPlayer);
		}
		break;

	case USERDEFS_RESPAWN_MONSTERS:
		if(bSet)
		{
			ud.respawn_monsters = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.respawn_monsters, sActor, sPlayer);
		}
		break;

	case USERDEFS_RESPAWN_ITEMS:
		if(bSet)
		{
			ud.respawn_items = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.respawn_items, sActor, sPlayer);
		}
		break;

	case USERDEFS_RESPAWN_INVENTORY:
		if(bSet)
		{
			ud.respawn_inventory = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.respawn_inventory, sActor, sPlayer);
		}
		break;

	case USERDEFS_RECSTAT:
		if(bSet)
		{
			ud.recstat = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.recstat, sActor, sPlayer);
		}
		break;

	case USERDEFS_MONSTERS_OFF:
		if(bSet)
		{
			ud.monsters_off = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.monsters_off, sActor, sPlayer);
		}
		break;

	case USERDEFS_BRIGHTNESS:
		if(bSet)
		{
			ud.brightness = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.brightness, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_RESPAWN_ITEMS:
		if(bSet)
		{
			ud.m_respawn_items = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_respawn_items, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_RESPAWN_MONSTERS:
		if(bSet)
		{
			ud.m_respawn_monsters = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_respawn_monsters, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_RESPAWN_INVENTORY:
		if(bSet)
		{
			ud.m_respawn_inventory = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_respawn_inventory, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_RECSTAT:
		if(bSet)
		{
			ud.m_recstat = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_recstat, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_MONSTERS_OFF:
		if(bSet)
		{
			ud.m_monsters_off = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_monsters_off, sActor, sPlayer);
		}
		break;

	case USERDEFS_DETAIL:
		if(bSet)
		{
			ud.detail = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.detail, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_FFIRE:
		if(bSet)
		{
			ud.m_ffire = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_ffire, sActor, sPlayer);
		}
		break;

	case USERDEFS_FFIRE:
		if(bSet)
		{
			ud.ffire = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.ffire, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_PLAYER_SKILL:
		if(bSet)
		{
			ud.m_player_skill = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_player_skill, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_LEVEL_NUMBER:
		if(bSet)
		{
			ud.m_level_number = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_level_number, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_VOLUME_NUMBER:
		if(bSet)
		{
			ud.m_volume_number = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_volume_number, sActor, sPlayer);
		}
		break;

	case USERDEFS_MULTIMODE:
		if(bSet)
		{
			ud.multimode = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.multimode, sActor, sPlayer);
		}
		break;

	case USERDEFS_PLAYER_SKILL:
		if(bSet)
		{
			ud.player_skill = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.player_skill, sActor, sPlayer);
		}
		break;

	case USERDEFS_LEVEL_NUMBER:
		if(bSet)
		{
			ud.level_number = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.level_number, sActor, sPlayer);
		}
		break;

	case USERDEFS_VOLUME_NUMBER:
		if(bSet)
		{
			ud.volume_number = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.volume_number, sActor, sPlayer);
		}
		break;

	case USERDEFS_M_MARKER:
		if(bSet)
		{
			ud.m_marker = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.m_marker, sActor, sPlayer);
		}
		break;

	case USERDEFS_MARKER:
		if(bSet)
		{
			ud.marker = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.marker, sActor, sPlayer);
		}
		break;

	case USERDEFS_MOUSEFLIP:
		if(bSet)
		{
			ud.mouseflip = lValue;
		}
		else
		{
			SetGameVarID((int)lVar2, ud.mouseflip, sActor, sPlayer);
		}
		break;


			
		default:
			break;
	}
	return;
}

///////////////////////////////////////////
void DoPlayer(char bSet, long lVar1, long lLabelID, long lVar2, short sActor, short sPlayer, long lParm2)
{
	int iPlayer;
	long lValue;
	long lTemp;

	lValue=GetGameVarID((int)lVar2, sActor, sPlayer);
	
	if(lVar1 == g_iThisActorID )
	{
		// if they've asked for 'this', then use 'this player'...
		iPlayer=g_p;
	}
	else
	{
		iPlayer=GetGameVarID((int)lVar1, sActor, sPlayer);
	}
	
	if(iPlayer<0 || iPlayer >= MAXPLAYERS)
		return;
	
	switch(lLabelID)
	{
		case PLAYER_ZOOM:
			if(bSet)
			{
				ps[iPlayer].zoom=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].zoom, sActor, sPlayer);
			}
			break;

		case PLAYER_EXITX:
			if(bSet)
			{
				ps[iPlayer].exitx=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].exitx, sActor, sPlayer);
			}
			break;

		case PLAYER_EXITY:
			if(bSet)
			{
				ps[iPlayer].exity=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].exity, sActor, sPlayer);
			}
			break;

		case PLAYER_LOOGIEX:
			if(bSet)
			{
				ps[iPlayer].loogiex[64]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].loogiex[64], sActor, sPlayer);
			}
			break;

		case PLAYER_LOOGIEY:
			if(bSet)
			{
				ps[iPlayer].loogiey[64]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].loogiey[64], sActor, sPlayer);
			}
			break;

		case PLAYER_NUMLOOGS:
			if(bSet)
			{
				ps[iPlayer].numloogs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].numloogs, sActor, sPlayer);
			}
			break;

		case PLAYER_LOOGCNT:
			if(bSet)
			{
				ps[iPlayer].loogcnt=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].loogcnt, sActor, sPlayer);
			}
			break;

		case PLAYER_POSX:
			if(bSet)
			{
				ps[iPlayer].posx=lValue;
//				setsprite(ps[iPlayer].i,ps[iPlayer].posx, ps[iPlayer].posy, ps[iPlayer].posz);
//				ps[iPlayer].cursectnum=sprite[ps[iPlayer].i].sectnum;
					
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].posx, sActor, sPlayer);
			}
			break;

		case PLAYER_POSY:
			if(bSet)
			{
				ps[iPlayer].posy=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].posy, sActor, sPlayer);
//				setsprite(ps[iPlayer].i,ps[iPlayer].posx, ps[iPlayer].posy, ps[iPlayer].posz);
//				ps[iPlayer].cursectnum=sprite[ps[iPlayer].i].sectnum;
			}
			break;

		case PLAYER_POSZ:
			if(bSet)
			{
				ps[iPlayer].posz=lValue;
				setsprite(ps[iPlayer].i,ps[iPlayer].posx, ps[iPlayer].posy, ps[iPlayer].posz);
				ps[iPlayer].cursectnum=sprite[ps[iPlayer].i].sectnum;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].posz, sActor, sPlayer);
			}
			break;

		case PLAYER_HORIZ:
			if(bSet)
			{
				ps[iPlayer].horiz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].horiz, sActor, sPlayer);
			}
			break;

		case PLAYER_OHORIZ:
			if(bSet)
			{
				ps[iPlayer].ohoriz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].ohoriz, sActor, sPlayer);
			}
			break;

		case PLAYER_OHORIZOFF:
			if(bSet)
			{
				ps[iPlayer].ohorizoff=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].ohorizoff, sActor, sPlayer);
			}
			break;

		case PLAYER_INVDISPTIME:
			if(bSet)
			{
				ps[iPlayer].invdisptime=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].invdisptime, sActor, sPlayer);
			}
			break;

		case PLAYER_BOBPOSX:
			if(bSet)
			{
				ps[iPlayer].bobposx=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].bobposx, sActor, sPlayer);
			}
			break;

		case PLAYER_BOBPOSY:
			if(bSet)
			{
				ps[iPlayer].bobposy=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].bobposy, sActor, sPlayer);
			}
			break;

		case PLAYER_OPOSX:
			if(bSet)
			{
				ps[iPlayer].oposx=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].oposx, sActor, sPlayer);
			}
			break;

		case PLAYER_OPOSY:
			if(bSet)
			{
				ps[iPlayer].oposy=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].oposy, sActor, sPlayer);
			}
			break;

		case PLAYER_OPOSZ:
			if(bSet)
			{
				ps[iPlayer].oposz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].oposz, sActor, sPlayer);
			}
			break;

		case PLAYER_PYOFF:
			if(bSet)
			{
				ps[iPlayer].pyoff=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].pyoff, sActor, sPlayer);
			}
			break;

		case PLAYER_OPYOFF:
			if(bSet)
			{
				ps[iPlayer].opyoff=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].opyoff, sActor, sPlayer);
			}
			break;

		case PLAYER_POSXV:
			if(bSet)
			{
				ps[iPlayer].posxv=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].posxv, sActor, sPlayer);
			}
			break;

		case PLAYER_POSYV:
			if(bSet)
			{
				ps[iPlayer].posyv=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].posyv, sActor, sPlayer);
			}
			break;

		case PLAYER_POSZV:
			if(bSet)
			{
				ps[iPlayer].poszv=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].poszv, sActor, sPlayer);
			}
			break;

		case PLAYER_LAST_PISSED_TIME:
			if(bSet)
			{
				ps[iPlayer].last_pissed_time=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].last_pissed_time, sActor, sPlayer);
			}
			break;

		case PLAYER_TRUEFZ:
			if(bSet)
			{
				ps[iPlayer].truefz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].truefz, sActor, sPlayer);
			}
			break;

		case PLAYER_TRUECZ:
			if(bSet)
			{
				ps[iPlayer].truecz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].truecz, sActor, sPlayer);
			}
			break;

		case PLAYER_PLAYER_PAR:
			if(bSet)
			{
				ps[iPlayer].player_par=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].player_par, sActor, sPlayer);
			}
			break;

		case PLAYER_VISIBILITY:
			if(bSet)
			{
				ps[iPlayer].visibility=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].visibility, sActor, sPlayer);
			}
			break;

		case PLAYER_BOBCOUNTER:
			if(bSet)
			{
				ps[iPlayer].bobcounter=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].bobcounter, sActor, sPlayer);
			}
			break;

		case PLAYER_WEAPON_SWAY:
			if(bSet)
			{
				ps[iPlayer].weapon_sway=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].weapon_sway, sActor, sPlayer);
			}
			break;

		case PLAYER_PALS_TIME:
			if(bSet)
			{
				ps[iPlayer].pals_time=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].pals_time, sActor, sPlayer);
			}
			break;

		case PLAYER_RANDOMFLAMEX:
			if(bSet)
			{
				ps[iPlayer].randomflamex=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].randomflamex, sActor, sPlayer);
			}
			break;

		case PLAYER_CRACK_TIME:
			if(bSet)
			{
				ps[iPlayer].crack_time=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].crack_time, sActor, sPlayer);
			}
			break;

		case PLAYER_AIM_MODE:
			if(bSet)
			{
				ps[iPlayer].aim_mode=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].aim_mode, sActor, sPlayer);
			}
			break;

		case PLAYER_ANG:
			if(bSet)
			{
				ps[iPlayer].ang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].ang, sActor, sPlayer);
			}
			break;

		case PLAYER_OANG:
			if(bSet)
			{
				ps[iPlayer].oang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].oang, sActor, sPlayer);
			}
			break;

		case PLAYER_ANGVEL:
			if(bSet)
			{
				ps[iPlayer].angvel=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].angvel, sActor, sPlayer);
			}
			break;

		case PLAYER_CURSECTNUM:
			if(bSet)
			{
				ps[iPlayer].cursectnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].cursectnum, sActor, sPlayer);
			}
			break;

		case PLAYER_LOOK_ANG:
			if(bSet)
			{
				ps[iPlayer].look_ang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].look_ang, sActor, sPlayer);
			}
			break;

		case PLAYER_LAST_EXTRA:
			if(bSet)
			{
				ps[iPlayer].last_extra=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].last_extra, sActor, sPlayer);
			}
			break;

		case PLAYER_SUBWEAPON:
			if(bSet)
			{
				ps[iPlayer].subweapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].subweapon, sActor, sPlayer);
			}
			break;

		case PLAYER_AMMO_AMOUNT:
			lTemp=GetGameVarID((int)lParm2, sActor, sPlayer);
			if(bSet)
			{
				ps[iPlayer].ammo_amount[lTemp]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].ammo_amount[lTemp], sActor, sPlayer);
			}
			break;

		case PLAYER_WACKEDBYACTOR:
			if(bSet)
			{
				ps[iPlayer].wackedbyactor=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].wackedbyactor, sActor, sPlayer);
			}
			break;

		case PLAYER_FRAG:
			if(bSet)
			{
				ps[iPlayer].frag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].frag, sActor, sPlayer);
			}
			break;

		case PLAYER_FRAGGEDSELF:
			if(bSet)
			{
				ps[iPlayer].fraggedself=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].fraggedself, sActor, sPlayer);
			}
			break;

		case PLAYER_CURR_WEAPON:
			if(bSet)
			{
				ps[iPlayer].curr_weapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].curr_weapon, sActor, sPlayer);
			}
			break;

		case PLAYER_LAST_WEAPON:
			if(bSet)
			{
				ps[iPlayer].last_weapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].last_weapon, sActor, sPlayer);
			}
			break;

		case PLAYER_TIPINCS:
			if(bSet)
			{
				ps[iPlayer].tipincs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].tipincs, sActor, sPlayer);
			}
			break;

		case PLAYER_HORIZOFF:
			if(bSet)
			{
				ps[iPlayer].horizoff=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].horizoff, sActor, sPlayer);
			}
			break;

		case PLAYER_WANTWEAPONFIRE:
			if(bSet)
			{
				ps[iPlayer].wantweaponfire=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].wantweaponfire, sActor, sPlayer);
			}
			break;

		case PLAYER_HOLODUKE_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].holoduke_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].holoduke_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_NEWOWNER:
			if(bSet)
			{
				ps[iPlayer].newowner=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].newowner, sActor, sPlayer);
			}
			break;

		case PLAYER_HURT_DELAY:
			if(bSet)
			{
				ps[iPlayer].hurt_delay=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].hurt_delay, sActor, sPlayer);
			}
			break;

		case PLAYER_HBOMB_HOLD_DELAY:
			if(bSet)
			{
				ps[iPlayer].hbomb_hold_delay=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].hbomb_hold_delay, sActor, sPlayer);
			}
			break;

		case PLAYER_JUMPING_COUNTER:
			if(bSet)
			{
				ps[iPlayer].jumping_counter=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].jumping_counter, sActor, sPlayer);
			}
			break;

		case PLAYER_AIRLEFT:
			if(bSet)
			{
				ps[iPlayer].airleft=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].airleft, sActor, sPlayer);
			}
			break;

		case PLAYER_KNEE_INCS:
			if(bSet)
			{
				ps[iPlayer].knee_incs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].knee_incs, sActor, sPlayer);
			}
			break;

		case PLAYER_ACCESS_INCS:
			if(bSet)
			{
				ps[iPlayer].access_incs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].access_incs, sActor, sPlayer);
			}
			break;

		case PLAYER_FTA:
			if(bSet)
			{
				ps[iPlayer].fta=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].fta, sActor, sPlayer);
			}
			break;

		case PLAYER_FTQ:
			if(bSet)
			{
				ps[iPlayer].ftq=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].ftq, sActor, sPlayer);
			}
			break;

		case PLAYER_ACCESS_WALLNUM:
			if(bSet)
			{
				ps[iPlayer].access_wallnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].access_wallnum, sActor, sPlayer);
			}
			break;

		case PLAYER_ACCESS_SPRITENUM:
			if(bSet)
			{
				ps[iPlayer].access_spritenum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].access_spritenum, sActor, sPlayer);
			}
			break;

		case PLAYER_KICKBACK_PIC:
			if(bSet)
			{
				ps[iPlayer].kickback_pic=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].kickback_pic, sActor, sPlayer);
			}
			break;

		case PLAYER_GOT_ACCESS:
			if(bSet)
			{
				ps[iPlayer].got_access=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].got_access, sActor, sPlayer);
			}
			break;

		case PLAYER_WEAPON_ANG:
			if(bSet)
			{
				ps[iPlayer].weapon_ang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].weapon_ang, sActor, sPlayer);
			}
			break;

		case PLAYER_FIRSTAID_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].firstaid_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].firstaid_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_SOMETHINGONPLAYER:
			if(bSet)
			{
				ps[iPlayer].somethingonplayer=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].somethingonplayer, sActor, sPlayer);
			}
			break;

		case PLAYER_ON_CRANE:
			if(bSet)
			{
				ps[iPlayer].on_crane=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].on_crane, sActor, sPlayer);
			}
			break;

		case PLAYER_I:
			if(bSet)
			{
				ps[iPlayer].i=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].i, sActor, sPlayer);
			}
			break;

		case PLAYER_ONE_PARALLAX_SECTNUM:
			if(bSet)
			{
				ps[iPlayer].one_parallax_sectnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].one_parallax_sectnum, sActor, sPlayer);
			}
			break;

		case PLAYER_OVER_SHOULDER_ON:
			if(bSet)
			{
				ps[iPlayer].over_shoulder_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].over_shoulder_on, sActor, sPlayer);
			}
			break;

		case PLAYER_RANDOM_CLUB_FRAME:
			if(bSet)
			{
				ps[iPlayer].random_club_frame=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].random_club_frame, sActor, sPlayer);
			}
			break;

		case PLAYER_FIST_INCS:
			if(bSet)
			{
				ps[iPlayer].fist_incs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].fist_incs, sActor, sPlayer);
			}
			break;

		case PLAYER_ONE_EIGHTY_COUNT:
			if(bSet)
			{
				ps[iPlayer].one_eighty_count=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].one_eighty_count, sActor, sPlayer);
			}
			break;

		case PLAYER_CHEAT_PHASE:
			if(bSet)
			{
				ps[iPlayer].cheat_phase=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].cheat_phase, sActor, sPlayer);
			}
			break;

		case PLAYER_DUMMYPLAYERSPRITE:
			if(bSet)
			{
				ps[iPlayer].dummyplayersprite=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].dummyplayersprite, sActor, sPlayer);
			}
			break;

		case PLAYER_EXTRA_EXTRA8:
			if(bSet)
			{
				ps[iPlayer].extra_extra8=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].extra_extra8, sActor, sPlayer);
			}
			break;

		case PLAYER_QUICK_KICK:
			if(bSet)
			{
				ps[iPlayer].quick_kick=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].quick_kick, sActor, sPlayer);
			}
			break;

		case PLAYER_HEAT_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].heat_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].heat_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_ACTORSQU:
			if(bSet)
			{
				ps[iPlayer].actorsqu=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].actorsqu, sActor, sPlayer);
			}
			break;

		case PLAYER_TIMEBEFOREEXIT:
			if(bSet)
			{
				ps[iPlayer].timebeforeexit=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].timebeforeexit, sActor, sPlayer);
			}
			break;

		case PLAYER_CUSTOMEXITSOUND:
			if(bSet)
			{
				ps[iPlayer].customexitsound=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].customexitsound, sActor, sPlayer);
			}
			break;

		case PLAYER_WEAPRECS:
			if(bSet)
			{
				ps[iPlayer].weaprecs[16]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].weaprecs[16], sActor, sPlayer);
			}
			break;

		case PLAYER_WEAPRECCNT:
			if(bSet)
			{
				ps[iPlayer].weapreccnt=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].weapreccnt, sActor, sPlayer);
			}
			break;

		case PLAYER_INTERFACE_TOGGLE_FLAG:
			if(bSet)
			{
				ps[iPlayer].interface_toggle_flag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].interface_toggle_flag, sActor, sPlayer);
			}
			break;

		case PLAYER_ROTSCRNANG:
			if(bSet)
			{
				ps[iPlayer].rotscrnang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].rotscrnang, sActor, sPlayer);
			}
			break;

		case PLAYER_DEAD_FLAG:
			if(bSet)
			{
				ps[iPlayer].dead_flag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].dead_flag, sActor, sPlayer);
			}
			break;

		case PLAYER_SHOW_EMPTY_WEAPON:
			if(bSet)
			{
				ps[iPlayer].show_empty_weapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].show_empty_weapon, sActor, sPlayer);
			}
			break;

		case PLAYER_SCUBA_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].scuba_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].scuba_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_JETPACK_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].jetpack_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].jetpack_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_STEROIDS_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].steroids_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].steroids_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_SHIELD_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].shield_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].shield_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_HOLODUKE_ON:
			if(bSet)
			{
				ps[iPlayer].holoduke_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].holoduke_on, sActor, sPlayer);
			}
			break;

		case PLAYER_PYCOUNT:
			if(bSet)
			{
				ps[iPlayer].pycount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].pycount, sActor, sPlayer);
			}
			break;

		case PLAYER_WEAPON_POS:
			if(bSet)
			{
				ps[iPlayer].weapon_pos=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].weapon_pos, sActor, sPlayer);
			}
			break;

		case PLAYER_FRAG_PS:
			if(bSet)
			{
				ps[iPlayer].frag_ps=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].frag_ps, sActor, sPlayer);
			}
			break;

		case PLAYER_TRANSPORTER_HOLD:
			if(bSet)
			{
				ps[iPlayer].transporter_hold=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].transporter_hold, sActor, sPlayer);
			}
			break;

		case PLAYER_LAST_FULL_WEAPON:
			if(bSet)
			{
				ps[iPlayer].last_full_weapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].last_full_weapon, sActor, sPlayer);
			}
			break;

		case PLAYER_FOOTPRINTSHADE:
			if(bSet)
			{
				ps[iPlayer].footprintshade=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].footprintshade, sActor, sPlayer);
			}
			break;

		case PLAYER_BOOT_AMOUNT:
			if(bSet)
			{
				ps[iPlayer].boot_amount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].boot_amount, sActor, sPlayer);
			}
			break;

		case PLAYER_SCREAM_VOICE:
			if(bSet)
			{
				ps[iPlayer].scream_voice=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].scream_voice, sActor, sPlayer);
			}
			break;

		case PLAYER_GM:
			if(bSet)
			{
				ps[iPlayer].gm=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].gm, sActor, sPlayer);
			}
			break;

		case PLAYER_ON_WARPING_SECTOR:
			if(bSet)
			{
				ps[iPlayer].on_warping_sector=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].on_warping_sector, sActor, sPlayer);
			}
			break;

		case PLAYER_FOOTPRINTCOUNT:
			if(bSet)
			{
				ps[iPlayer].footprintcount=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].footprintcount, sActor, sPlayer);
			}
			break;

		case PLAYER_HBOMB_ON:
			if(bSet)
			{
				ps[iPlayer].hbomb_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].hbomb_on, sActor, sPlayer);
			}
			break;

		case PLAYER_JUMPING_TOGGLE:
			if(bSet)
			{
				ps[iPlayer].jumping_toggle=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].jumping_toggle, sActor, sPlayer);
			}
			break;

		case PLAYER_RAPID_FIRE_HOLD:
			if(bSet)
			{
				ps[iPlayer].rapid_fire_hold=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].rapid_fire_hold, sActor, sPlayer);
			}
			break;

		case PLAYER_ON_GROUND:
			if(bSet)
			{
				ps[iPlayer].on_ground=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].on_ground, sActor, sPlayer);
			}
			break;

		case PLAYER_NAME:
			if(bSet)
			{
				ps[iPlayer].name[32]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].name[32], sActor, sPlayer);
			}
			break;

		case PLAYER_INVEN_ICON:
			if(bSet)
			{
				ps[iPlayer].inven_icon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].inven_icon, sActor, sPlayer);
			}
			break;

		case PLAYER_BUTTONPALETTE:
			if(bSet)
			{
				ps[iPlayer].buttonpalette=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].buttonpalette, sActor, sPlayer);
			}
			break;

		case PLAYER_JETPACK_ON:
			if(bSet)
			{
				ps[iPlayer].jetpack_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].jetpack_on, sActor, sPlayer);
			}
			break;

		case PLAYER_SPRITEBRIDGE:
			if(bSet)
			{
				ps[iPlayer].spritebridge=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].spritebridge, sActor, sPlayer);
			}
			break;

		case PLAYER_LASTRANDOMSPOT:
			if(bSet)
			{
				ps[iPlayer].lastrandomspot=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].lastrandomspot, sActor, sPlayer);
			}
			break;

		case PLAYER_SCUBA_ON:
			if(bSet)
			{
				ps[iPlayer].scuba_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].scuba_on, sActor, sPlayer);
			}
			break;

		case PLAYER_FOOTPRINTPAL:
			if(bSet)
			{
				ps[iPlayer].footprintpal=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].footprintpal, sActor, sPlayer);
			}
			break;

		case PLAYER_HEAT_ON:
			if(bSet)
			{
				ps[iPlayer].heat_on=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].heat_on, sActor, sPlayer);
			}
			break;

		case PLAYER_HOLSTER_WEAPON:
			if(bSet)
			{
				ps[iPlayer].holster_weapon=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].holster_weapon, sActor, sPlayer);
			}
			break;

		case PLAYER_FALLING_COUNTER:
			if(bSet)
			{
				ps[iPlayer].falling_counter=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].falling_counter, sActor, sPlayer);
			}
			break;

		case PLAYER_GOTWEAPON:
			if(bSet)
			{
				ps[iPlayer].gotweapon[MAX_WEAPONS]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].gotweapon[MAX_WEAPONS], sActor, sPlayer);
			}
			break;

		case PLAYER_REFRESH_INVENTORY:
			if(bSet)
			{
				ps[iPlayer].refresh_inventory=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].refresh_inventory, sActor, sPlayer);
			}
			break;

//		case PLAYER_PALETTE:
//			if(bSet)
//			{
//				ps[iPlayer].palette=lValue;
//			}
//			else
//			{
//				SetGameVarID((int)lVar2, ps[iPlayer].palette, sActor, sPlayer);
//			}
//			break;

		case PLAYER_TOGGLE_KEY_FLAG:
			if(bSet)
			{
				ps[iPlayer].toggle_key_flag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].toggle_key_flag, sActor, sPlayer);
			}
			break;

		case PLAYER_KNUCKLE_INCS:
			if(bSet)
			{
				ps[iPlayer].knuckle_incs=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].knuckle_incs, sActor, sPlayer);
			}
			break;

		case PLAYER_WALKING_SND_TOGGLE:
			if(bSet)
			{
				ps[iPlayer].walking_snd_toggle=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].walking_snd_toggle, sActor, sPlayer);
			}
			break;

		case PLAYER_PALOOKUP:
			if(bSet)
			{
				ps[iPlayer].palookup=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].palookup, sActor, sPlayer);
			}
			break;

		case PLAYER_HARD_LANDING:
			if(bSet)
			{
				ps[iPlayer].hard_landing=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].hard_landing, sActor, sPlayer);
			}
			break;

		case PLAYER_MAX_SECRET_ROOMS:
			if(bSet)
			{
				ps[iPlayer].max_secret_rooms=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].max_secret_rooms, sActor, sPlayer);
			}
			break;

		case PLAYER_SECRET_ROOMS:
			if(bSet)
			{
				ps[iPlayer].secret_rooms=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].secret_rooms, sActor, sPlayer);
			}
			break;

		case PLAYER_PALS:
			if(bSet)
			{
				ps[iPlayer].pals[3]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].pals[3], sActor, sPlayer);
			}
			break;

		case PLAYER_MAX_ACTORS_KILLED:
			if(bSet)
			{
				ps[iPlayer].max_actors_killed=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].max_actors_killed, sActor, sPlayer);
			}
			break;

		case PLAYER_ACTORS_KILLED:
			if(bSet)
			{
				ps[iPlayer].actors_killed=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].actors_killed, sActor, sPlayer);
			}
			break;

		case PLAYER_RETURN_TO_CENTER:
			if(bSet)
			{
				ps[iPlayer].return_to_center=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, ps[iPlayer].return_to_center, sActor, sPlayer);
			}
			break;

			
		default:
			break;
	}
	return;
}

////////////////////
void DoWall(char bSet, long lVar1, long lLabelID, long lVar2, short sActor, short sPlayer, long lParm2)
{
	int iWall;
	long lValue;

	lValue=GetGameVarID((int)lVar2, sActor, sPlayer);
	
	iWall=GetGameVarID((int)lVar1, sActor, sPlayer);
	
	if(iWall<0 || iWall >= MAXWALLS)
		return;
	
	switch(lLabelID)
	{
		case WALL_X:
			if(bSet)
			{
				wall[iWall].x=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].x, sActor, sPlayer);
			}
			break;
		case WALL_Y:
			if(bSet)
			{
				wall[iWall].y=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].y, sActor, sPlayer);
			}
			break;
		case WALL_POINT2:
			if(bSet)
			{
				wall[iWall].point2=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].point2, sActor, sPlayer);
			}
			break;
		case WALL_NEXTWALL:
			if(bSet)
			{
				wall[iWall].nextwall=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].nextwall, sActor, sPlayer);
			}
			break;
		case WALL_NEXTSECTOR:
			if(bSet)
			{
				wall[iWall].nextsector=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].nextsector, sActor, sPlayer);
			}
			break;
		case WALL_CSTAT:
			if(bSet)
			{
				wall[iWall].cstat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].cstat, sActor, sPlayer);
			}
			break;
		case WALL_PICNUM:
			if(bSet)
			{
				wall[iWall].picnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].picnum, sActor, sPlayer);
			}
			break;
		case WALL_OVERPICNUM:
			if(bSet)
			{
				wall[iWall].overpicnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].overpicnum, sActor, sPlayer);
			}
			break;
		case WALL_SHADE:
			if(bSet)
			{
				wall[iWall].x=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].shade, sActor, sPlayer);
			}
			break;
		case WALL_PAL:
			if(bSet)
			{
				wall[iWall].pal=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].pal, sActor, sPlayer);
			}
			break;
		case WALL_XREPEAT:
			if(bSet)
			{
				wall[iWall].xrepeat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].xrepeat, sActor, sPlayer);
			}
			break;
		case WALL_YREPEAT:
			if(bSet)
			{
				wall[iWall].yrepeat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].yrepeat, sActor, sPlayer);
			}
			break;
		case WALL_XPANNING:
			if(bSet)
			{
				wall[iWall].xpanning=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].xpanning, sActor, sPlayer);
			}
			break;
		case WALL_YPANNING:
			if(bSet)
			{
				wall[iWall].ypanning=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].ypanning, sActor, sPlayer);
			}
			break;
		case WALL_LOTAG:
			if(bSet)
			{
				wall[iWall].lotag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].lotag, sActor, sPlayer);
			}
			break;
		case WALL_HITAG:
			if(bSet)
			{
				wall[iWall].hitag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].hitag, sActor, sPlayer);
			}
			break;
		case WALL_EXTRA:
			if(bSet)
			{
				wall[iWall].x=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, wall[iWall].x, sActor, sPlayer);
			}
			break;
		default:
			break;
	}
	return;
}

void DoSector(char bSet, long lVar1, long lLabelID, long lVar2, short sActor, short sPlayer, long lParm2)
{
	int iSector;
	long lValue;

	
	if(lVar1 == g_iThisActorID )
	{
		// if they've asked for 'this', then use 'this'...
		iSector=sprite[g_i].sectnum;
	}
	else
	{
		iSector=GetGameVarID((int)lVar1, sActor, sPlayer);
	}
	
	if(iSector<0 || iSector >= MAXSECTORS)
		return;

	lValue=GetGameVarID((int)lVar2, sActor, sPlayer);
	
	switch(lLabelID)
	{
		case SECTOR_WALLPTR:
			if(bSet)
			{
				sector[iSector].wallptr=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].wallptr,sActor,sPlayer);
			}
			break;
		case SECTOR_WALLNUM:
			if(bSet)
			{
				sector[iSector].wallnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].wallnum,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGZ:
			if(bSet)
			{
				sector[iSector].ceilingz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingz,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORZ:
			if(bSet)
			{
				sector[iSector].floorz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorz,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGSTAT:
			if(bSet)
			{
				sector[iSector].ceilingstat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingstat,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORSTAT:
			if(bSet)
			{
				sector[iSector].floorstat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorstat,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGPICNUM:
			if(bSet)
			{
				sector[iSector].ceilingpicnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingpicnum,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGSLOPE:
			if(bSet)
			{
				sector[iSector].ceilingheinum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingheinum,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGSHADE:
			if(bSet)
			{
				sector[iSector].ceilingshade=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingshade,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGPAL:
			if(bSet)
			{
				sector[iSector].ceilingpal=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingpal,sActor,sPlayer);
			}
			break;
		case SECTOR_CEILINGXPANNING:
			if(bSet)
			{
				sector[iSector].ceilingxpanning=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].ceilingypanning,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORPICNUM:
			if(bSet)
			{
				sector[iSector].floorpicnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorpicnum,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORSLOPE:
			if(bSet)
			{
				sector[iSector].floorheinum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorheinum,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORSHADE:
			if(bSet)
			{
				sector[iSector].floorshade=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorshade,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORPAL:
			if(bSet)
			{
				sector[iSector].floorpal=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorpal,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORXPANNING:
			if(bSet)
			{
				sector[iSector].floorxpanning=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorxpanning,sActor,sPlayer);
			}
			break;
		case SECTOR_FLOORYPANNING:
			if(bSet)
			{
				sector[iSector].floorypanning=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].floorypanning,sActor,sPlayer);
			}
			break;
		case SECTOR_VISIBILITY:
			if(bSet)
			{
				sector[iSector].visibility=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].visibility,sActor,sPlayer);
			}
			break;
		case SECTOR_ALIGNTO:
			if(bSet)
			{
				sector[iSector].filler=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].filler,sActor,sPlayer);
			}
			break;
		case SECTOR_LOTAG:
			if(bSet)
			{
				sector[iSector].lotag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].lotag,sActor,sPlayer);
			}
			break;
		case SECTOR_HITAG:
			if(bSet)
			{
				sector[iSector].hitag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].hitag,sActor,sPlayer);
			}
			break;
		case SECTOR_EXTRA:
			if(bSet)
			{
				sector[iSector].extra=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sector[iSector].extra,sActor,sPlayer);
			}
			
			break;
		default:
			break;
			
	}
	return;
}
void DoActor(char bSet, long lVar1, long lLabelID, long lVar2, short sActor, short sPlayer, long lParm2)
{
	int iActor;
	long lValue;

	lValue=GetGameVarID((int)lVar2, sActor, sPlayer);

	if(lVar1 == g_iThisActorID )
	{
		// if they've asked for 'this', then use 'this'...
		iActor=g_i;
	}
	else
	{
		iActor=GetGameVarID((int)lVar1, sActor, sPlayer);
	}
	
	if(iActor < 0 || iActor >= MAXSPRITES)
		return;
	
	switch(lLabelID)
	{
		case ACTOR_X:
			if(bSet)
			{
				sprite[iActor].x=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].x,sActor,sPlayer);
			}
			break;
		case ACTOR_Y:
			if(bSet)
			{
				sprite[iActor].y=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].y,sActor,sPlayer);
			}
			break;
		case ACTOR_Z:
			if(bSet)
			{
				sprite[iActor].z=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].z,sActor,sPlayer);
			}
			break;
		case ACTOR_CSTAT:
			if(bSet)
			{
				sprite[iActor].cstat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].cstat,sActor,sPlayer);
			}
			break;
		case ACTOR_PICNUM:
			if(bSet)
			{
				sprite[iActor].picnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].picnum,sActor,sPlayer);
			}
			break;
		case ACTOR_SHADE:
			if(bSet)
			{
				sprite[iActor].shade=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].shade,sActor,sPlayer);
			}
			break;
		case ACTOR_PAL:
			if(bSet)
			{
				sprite[iActor].pal=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].pal,sActor,sPlayer);
			}
			break;
		case ACTOR_CLIPDIST:
			if(bSet)
			{
				sprite[iActor].clipdist=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].clipdist,sActor,sPlayer);
			}
			break;
		case ACTOR_DETAIL:
			if(bSet)
			{
				sprite[iActor].filler=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].filler,sActor,sPlayer);
			}
			break;
		case ACTOR_XREPEAT:
			if(bSet)
			{
				sprite[iActor].xrepeat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].xrepeat,sActor,sPlayer);
			}
			break;
		case ACTOR_YREPEAT:
			if(bSet)
			{
				sprite[iActor].yrepeat=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].yrepeat,sActor,sPlayer);
			}
			break;
		case ACTOR_XOFFSET:
			if(bSet)
			{
				sprite[iActor].xoffset=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].xoffset,sActor,sPlayer);
			}
			break;
		case ACTOR_YOFFSET:
			if(bSet)
			{
				sprite[iActor].yoffset=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].yoffset,sActor,sPlayer);
			}
			break;
		case ACTOR_SECTNUM:
			if(bSet)
			{
				sprite[iActor].sectnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].sectnum,sActor,sPlayer);
			}
			break;
		case ACTOR_STATNUM:
			if(bSet)
			{
				sprite[iActor].statnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].statnum,sActor,sPlayer);
			}
			break;
		case ACTOR_ANG:
			if(bSet)
			{
				sprite[iActor].ang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].ang,sActor,sPlayer);
			}
			break;
		case ACTOR_OWNER:
			if(bSet)
			{
				sprite[iActor].owner=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].owner,sActor,sPlayer);
			}
			break;
		case ACTOR_XVEL:
			if(bSet)
			{
				sprite[iActor].xvel=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].xvel,sActor,sPlayer);
			}
			break;
		case ACTOR_YVEL:
			if(bSet)
			{
				sprite[iActor].yvel=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].yvel,sActor,sPlayer);
			}
			break;
		case ACTOR_ZVEL:
			if(bSet)
			{
				sprite[iActor].zvel=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].zvel,sActor,sPlayer);
			}
			break;
		case ACTOR_LOTAG:
			if(bSet)
			{
				sprite[iActor].lotag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].lotag,sActor,sPlayer);
			}
			break;
		case ACTOR_HITAG:
			if(bSet)
			{
				sprite[iActor].hitag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].hitag,sActor,sPlayer);
			}
			break;
		case ACTOR_EXTRA:
			if(bSet)
			{
				sprite[iActor].extra=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, sprite[iActor].extra,sActor,sPlayer);
			}
			break;

		case ACTOR_HTCGG:
			if(bSet)
			{
				hittype[iActor].cgg=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, hittype[iActor].cgg, sActor, sPlayer);
			}
			break;
		case ACTOR_HTPICNUM	:
			if(bSet)
			{
				hittype[iActor].picnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, hittype[iActor].picnum, sActor, sPlayer);
			}
			break;
		case ACTOR_HTANG:
			if(bSet)
			{
				hittype[iActor].ang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2, hittype[iActor].ang, sActor, sPlayer);
			}
			break;
		case ACTOR_HTEXTRA:
			if(bSet)
			{
				hittype[iActor].extra=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].extra, sActor, sPlayer);
			}
			break;
		case ACTOR_HTOWNER:
			if(bSet)
			{
				hittype[iActor].owner=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].owner, sActor, sPlayer);
			}
			break;
		case ACTOR_HTMOVFLAG:
			if(bSet)
			{
				hittype[iActor].movflag=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].movflag, sActor, sPlayer);
			}
			break;
		case ACTOR_HTTEMPANG:
			if(bSet)
			{
				hittype[iActor].tempang=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].tempang, sActor, sPlayer);
			}
			break;
		case ACTOR_HTACTORSTAYPUT:
			if(bSet)
			{
				hittype[iActor].actorstayput=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].actorstayput, sActor, sPlayer);
			}
			break;
		case ACTOR_HTDISPICNUM:
			if(bSet)
			{
				hittype[iActor].dispicnum=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].dispicnum, sActor, sPlayer);
			}
			break;
		case ACTOR_HTTIMETOSLEEP:
			if(bSet)
			{
				hittype[iActor].timetosleep=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].timetosleep, sActor, sPlayer);
			}
			break;
		case ACTOR_HTFLOORZ:
			if(bSet)
			{
				hittype[iActor].floorz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].floorz, sActor, sPlayer);
			}
			break;
		case ACTOR_HTCEILINGZ:
			if(bSet)
			{
				hittype[iActor].ceilingz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].ceilingz, sActor, sPlayer);
			}
			break;
		case ACTOR_HTLASTVX:
			if(bSet)
			{
				hittype[iActor].lastvx=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].lastvx, sActor, sPlayer);
			}
			break;
		case ACTOR_HTLASTVY:
			if(bSet)
			{
				hittype[iActor].lastvy=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].lastvy, sActor, sPlayer);
			}
			break;
		case ACTOR_HTBPOSX:
			if(bSet)
			{
				hittype[iActor].bposx=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].bposx, sActor, sPlayer);
			}
			break;
		case ACTOR_HTBPOSY:
			if(bSet)
			{
				hittype[iActor].bposy=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].bposy, sActor, sPlayer);
			}
			break;
		case ACTOR_HTBPOSZ:
			if(bSet)
			{
				hittype[iActor].bposz=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].bposz, sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T0:
			if(bSet)
			{
				hittype[iActor].temp_data[0]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[0], sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T1:
			if(bSet)
			{
				hittype[iActor].temp_data[1]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[1], sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T2:
			if(bSet)
			{
				hittype[iActor].temp_data[2]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[2], sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T3:
			if(bSet)
			{
				hittype[iActor].temp_data[3]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[3], sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T4:
			if(bSet)
			{
				hittype[iActor].temp_data[4]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[4], sActor, sPlayer);
			}
			break;
		case ACTOR_HTG_T5:
			if(bSet)
			{
				hittype[iActor].temp_data[5]=lValue;
			}
			else
			{
				SetGameVarID((int)lVar2,hittype[iActor].temp_data[5], sActor, sPlayer);
			}
			break;
			
		default:
			break;
	}
	return;
}


void ResetSystemDefaults(void)
{
	// call many times...
	
	int i,j;
	char aszBuf[64];

AddLog("ResetSystemDefaults");

	for(j=0;j<MAXPLAYERS;j++)
	{
		for(i=0;i<MAX_WEAPONS;i++)
		{
			sprintf(aszBuf,"WEAPON%d_CLIP",i);
			aplWeaponClip[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_RELOAD",i);
			aplWeaponReload[i][j]=GetGameVar(aszBuf,0, -1, j);

			sprintf(aszBuf,"WEAPON%d_FIREDELAY",i);
			aplWeaponFireDelay[i][j]=GetGameVar(aszBuf,0, -1, j);

			sprintf(aszBuf,"WEAPON%d_TOTALTIME",i);
			aplWeaponTotalTime[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_HOLDDELAY",i);
			aplWeaponHoldDelay[i][j]=GetGameVar(aszBuf,0, -1, j);

			sprintf(aszBuf,"WEAPON%d_FLAGS",i);
			aplWeaponFlags[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_SHOOTS",i);
			aplWeaponShoots[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_SPAWNTIME",i);
			aplWeaponSpawnTime[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_SPAWN",i);
			aplWeaponSpawn[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_SHOTSPERBURST",i);
			aplWeaponShotsPerBurst[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_WORKSLIKE",i);
			aplWeaponWorksLike[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_INITIALSOUND",i);
			aplWeaponInitialSound[i][j]=GetGameVar(aszBuf,0, -1, j);
		
			sprintf(aszBuf,"WEAPON%d_FIRESOUND",i);
			aplWeaponFireSound[i][j]=GetGameVar(aszBuf,0, -1, j);

			sprintf(aszBuf,"WEAPON%d_SOUND2TIME",i);
			aplWeaponSound2Time[i][j]=GetGameVar(aszBuf,0, -1, j);

			sprintf(aszBuf,"WEAPON%d_SOUND2SOUND",i);
			aplWeaponSound2Sound[i][j]=GetGameVar(aszBuf,0, -1, j);
	
		}
	}

	g_iReturnVarID=GetGameID("RETURN");
	g_iWeaponVarID=GetGameID("WEAPON");
	g_iWorksLikeVarID=GetGameID("WORKSLIKE");
	g_iZRangeVarID=GetGameID("ZRANGE");
	g_iAngRangeVarID=GetGameID("ANGRANGE");
	g_iAimAngleVarID=GetGameID("AUTOAIMANGLE");
#ifdef EDUKE
	g_iAtWithVarID=GetGameID("ATWITH");
	g_iLoTagID=GetGameID("LOTAG");
	g_iHiTagID=GetGameID("HITAG");
	g_iTextureID=GetGameID("TEXTURE");
	g_iThisActorID=GetGameID("THISACTOR");
#endif

AddLog("EOF:ResetWeaponDefaults");

}
	
	
